﻿<?php
  
  /**
	* Checkpoints Live plugin by Lambda (hello.lambda@yahoo.com) 
	* test plugin v1.2 - XAseco(v1.11) Time Attack mode
	* 13-Avg-2010, tested on PHP v5.3.1 Linux
	*
	* update 6-Nov-2010
	* - some code improvement...
	* - © -> &#169;
	**/
  
  global $num_rows, $xfr, $yfr, $mal_id, $mal_pl;
  global $colr1, $colr2, $colr3, $colour4, $colour5, $colour6, $colour7;
  global $add_to_login;
  
  //*** CONFIGURATION ***//

  //number of displayed rows
  $num_rows = 15;			//12-15 players works fine
  
  //frame position - under TV (spec)
  $xfr = -64.0;			//horizontal (-64.4)
  $yfr = 28.7;			//vertical (22.7)
  $mal_id = 194217;			//manialink Title ID
  $mal_pl = 1;				//+ manialink Players ID
  $add_to_login = '_';		//login prefix
  
  //colors
  $colr1 = 'FFE';    //Title Checkpoints Live    
  $colr2 = 'ABC';    //Track text
  $colr3 = '9B1';    //Track numbers
  $colour4 = '567';    //Position number
  $colour5 = 'F93';    //CP- Text
  $colour6 = 'F93';    //cp's numbers
  $colour7 = 'FFC';    //Time
  
  //*** END CONFIGURATION ***//  
  
  Aseco::registerEvent('onSync', 'cplive_control_start');
  Aseco::registerEvent('onRestartChallenge', 'cplive_restart');
  Aseco::registerEvent('onNewChallenge', 'get_cp_s');
  Aseco::registerEvent('onPlayerConnect', 'cplive_player_on');
  Aseco::registerEvent('onCheckpoint', 'cplive_get_cp');  
  Aseco::registerEvent('onPlayerFinish', 'cplive_give_up');
  Aseco::registerEvent('onEndRound', 'cplive_list_cp_end');
  Aseco::registerEvent('onBeginRound', 'cplive_reset_all');
  Aseco::registerEvent('onPlayerDisconnect', 'cplive_player_off');
  
  global $Players, $CpNb, $list, $List, $all_cps, $malink_id;
  
  $Players = array();
  $CpNb = array();
  $malink_id = $mal_id + $mal_pl; 

  //onSync
  function cplive_control_start($lambda){  
	get_cp_s($lambda);
  }
    
  //onRestartChallenge
  function cplive_restart($lambda){	
	cplive_list_cp_end($lambda);
  }
  
  //onPlayerConnect
  function cplive_player_on($lambda, $ondata){
	global $Players, $CpNb;
  	global $add_to_login;
	
	$login = $ondata->login . $add_to_login;    
	$nickname = $ondata->nickname;
	
	if (is_string($login)){
		$Players[$login] = array("Nickname" => $nickname);
           
		//default value
		$CpNb[$login] = array("CPNumber" => 0,
							"Time" => '');
						  
		//check if value exist (?!)
		if(!in_array($nickname, $Players[$login], true)){
			unset($Players[$login]);
			unset($CpNb[$login]);    
		}
	title_row($lambda);
	cplive_list($lambda);		
	}                           
  }
  	
  //onCheckpoint
  function cplive_get_cp($lambda, $cpdata){ 
    global $Players, $CpNb;
	global $add_to_login;

	$login = $cpdata[1] . $add_to_login;
    
	$CpNb[$login] = array("CPNumber" => $cpdata[4]+1, 
						"Time" => $cpdata[2]);    
    	
    if(!array_key_exists($login, $CpNb)){
        unset($Players[$login]);
        unset($CpNb[$login]);    
    }	
	cplive_list($lambda);
  }

  //onPlayerFinish
  function cplive_give_up($lambda, $finish){  
	global $Players, $CpNb;
	global $add_to_login;
	
	$login = $finish->player->login . $add_to_login;
	$cps = $finish->challenge->nbchecks;

	if ($CpNb[$login]["CPNumber"] != $cps) {
			$CpNb[$login] = array ("CPNumber" => 0,
								"Time" => '');
			cplive_list($lambda);
	}
  }

  //onEndRound
  function cplive_list_cp_end ($lambda){
    global $mal_id, $malink_id;
	
	$hud = '<manialinks>';
	$hud .= '<manialink id="'.$mal_id.'" />';
	$hud .= '<manialink id="'.$malink_id.'" />';
	$hud .= '</manialinks>';
    
	$lambda->client->query("SendDisplayManialinkPage", $hud, 1, false);
  } 

  //onBeginRound    
  function cplive_reset_all($lambda){
    global $CpNb;
	global $add_to_login;

    foreach ($lambda->server->players->player_list as $tpl) {    
             $login = $tpl->login . $add_to_login;
        
    $CpNb[$login] = array("CPNumber" => 0,
						"Time" => '');	
   	}    
	cplive_list($lambda);
  }
        
  //onPlayerDisconnect
  function cplive_player_off ($lambda, $info){
    global $Players, $CpNb, $list;
	global $add_to_login;
    
    $login = $info->login . $add_to_login;
    
    unset($Players[$login]);   
    unset($CpNb[$login]);
    unset($list[$login]);

    cplive_list($lambda);
  }
  
  //*** Func ***//
  
  //get track cp's
  function get_cp_s($lambda){
	global $all_cps;
	
	$lambda->client->query('GetCurrentChallengeInfo');
    $CCInfo = $lambda->client->getResponse();
    $all_cps = ($CCInfo['NbCheckpoints'])-1; //last cp = finish
  
  	title_row($lambda);
  }
    
  //sort 2D array by value
  function subval_sort($a,$subkey){
	
	foreach($a as $k=>$v){
        $b[$k] = strtolower($v[$subkey]);
    }
    arsort($b);    //numbers
    foreach($b as $k=>$v){
                $c[] = $a[$k];
    }
    return $c;
  }

  //format time
  function format_time($ms){
    
	$sec = floor($ms/1000);
    $hun = ($ms - ($sec * 1000)) / 10;
    $min = floor ($sec / 60);
    $_sec = $sec % 60;

    $time = sprintf('%02d:%02d.%02d', $min, $_sec, $hun);
    return $time;
  }
  
  //update List
  function cplive_list($lambda){
	global $Players, $CpNb;
	global $num_rows;
	global $list, $List;

	//copy array
    $List = $list = array_merge_recursive($Players, $CpNb);
  
    //show only when array is not empty (?!)
    if (empty($list) == array()){
  
    //sort by highest curr cp nuber
    $List = subval_sort($List, "CPNumber"); 
  
    //number of rows for displaying
    $List = array_slice($List, 0, $num_rows);
   	}
   	display_hud($lambda);
  }
    
  //Title row
  function title_row($lambda){
	global $all_cps, $Players;
	global $xfr, $yfr, $mal_id;
	global $colr1, $colr2, $colr3;
	
	$url_textt = "http://en.wikipedia.org/wiki/Copyright";
	$url_cpy = htmlspecialchars($url_textt);
	$c_sign = '&#169;';
	
	foreach ($Players as $key=>$hud){
			$login = $key;
	
	//echo $login;
	$hud = '<?xml version="1.0" encoding="UTF-8"?>';
    $hud .= '<manialink id="'.$mal_id.'">';
    $hud .= '<frame scale="1" posn="'.$xfr.' '.$yfr.'">';    
/*
	// Copyright -> link to wikipedia	// just for test
	$hud .= '<label scale="0.54" posn="0.4 1.7 -0.14" halign="left" valign="center" style="TextButtonSmall" text="$666$s'.$c_sign.'" url="'.$url_cpy.'"/>';
	$hud .= '<label scale="0.38" posn="1.2 1.7 -0.14" halign="left" valign="center" style="TextRaceMessage" text="$666$i$s Lambda"/>';
*/	
	$hud .= '<quad posn="0 0 0" sizen="14.2 2 0.08" halign="left" valign="center" style="BgsPlayerCard" substyle="BgCard" />';
    $hud .= '<label scale="0.45" posn="0.4 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colr1.' Cp Live"/>';    
    $hud .= '<label scale="0.45" posn="6 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colr2.'Track cp\'s:"/>'; 
    $hud .= '<label scale="0.45" posn="12.6 0.1 0.1" halign="center" valign="center" style="TextRaceMessage" text="$'.$colr3.''.$all_cps.'"/>'; 		
	$hud .= '</frame>';
	$hud .= '</manialink>';
	
    $lambda->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
	}
  }
  
  //display hud
  function display_hud($lambda){      
    global $List, $Players;
    global $all_cps;
    global $xfr, $yfr, $malink_id;
    global $colour4, $colour5, $colour6, $colour7;

	foreach ($Players as $key=>$hud){
			$login = $key;
		
	$hud = '<manialink id="'.$malink_id.'">';
		
	$pid = 1;
    
    //vertical position (players)
    $y_fr = $yfr - 1.9;
    
    //replace Capitals ($t), wide ($w), bold ($o), italic($i), shadow($s), double-quote("), link($l)
    $replace_a = array('$t','$w','$o','$i','$s','$l','"');
    $replace_b = array("","","","","","","''");
    
        foreach ($List as $tcp){

            $hud .= '<frame scale="1" posn="'.$xfr.' '.$y_fr.'">';
            $hud .= '<label scale="0.48" posn="0.3 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour4.''.str_pad($pid, 2, '0', STR_PAD_LEFT).'"/>';  
            
            if (($tcp['CPNumber']-1) === $all_cps){
                $hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour5.'CP-"/>';
                $hud .= '<quad posn="4 0 0" sizen="1.6 1.6" halign="left" valign="center" style="BgRaceScore2" substyle="Warmup"/>';
            }else{
            $hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$'.$colour5.'CP-$'.$colour6.''.$tcp['CPNumber'].'"/>';
            }
            
            $hud .= '<label scale="0.48" posn="10.4 0.1 0.1" halign="right" valign="center" style="TextRaceMessage" text="$'.$colour7.''.format_time($tcp['Time']).'"/>';
            $hud .= '<label scale="0.48" posn="10.6 0.1 0.1" sizen="20.5 2" halign="left" valign="center" style="TextRaceMessage" text="'.str_ireplace($replace_a, $replace_b, trim($tcp['Nickname'])).'"/>';
            $hud .= '</frame>';
            $y_fr -= 1.8;
            $pid++;
        }
        
    $hud .= '</manialink>';
    $lambda->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
	}
  }
   
?>
